// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
//
//   Traits Definition
//   $Id: Traits.C,v 1.1 1997/04/09 17:01:22 wenger Exp $
//
//   Copyright 1997, Shaun Flisakowski
//
//   You may distribute under the terms of either the GNU General Public
//   License or the Artistic License, as specified in the README file.
//
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#include  "Traits.h"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

char *trait_name[No_of_Traits+1] = {

    "sorted",
    "unique",
    "consecutive",

    "null_allowed",

    ""         // No_of_Traits
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
// Make a duplicate 
Traits *Traits::dup()
{
    Traits *that = new Traits();

    memcpy(that->_traits,_traits,BM_SIZE);

    return that;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
// Stream printing (for debugging)
ostream& operator<< (ostream& out, const Traits& t)
{
    int j, n=0;

    // Print as a comma-seperated list
    for (j=0; j < No_of_Traits; j++)
        if (IS_SET(t._traits,j)) {

            if (!n)
                n = 1;
            else 
                out << ", "; 

            out << trait_name[j];
        }

    if (!n)
        out << "<no traits defined>";

    return out;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
